// main.cpp - Demoing our SyncReader or AsyncReader class

#include <iostream>
#include <chrono>
#include <thread>

// #include "sync_reader.h"
#include "async_reader.h"

int main()
{
    constexpr int num_to_read = 25;

    boost::asio::io_context ctx;
    boost::asio::thread_pool th(1);

    // SyncReader reader;
    AsyncReader reader(ctx);
	// prevent the ctx.run() call from finishing if the buffer fills up
	boost::asio::executor_work_guard guard{ctx.get_executor()};
    
    boost::asio::post(th, [&](){ ctx.run(); });

    for (auto i = 0; i < num_to_read; i++)
    {
        reader.getInt([](int i){ std::cout << i << std::endl; });
        std::this_thread::sleep_for(std::chrono::milliseconds{100});
    }

	guard.reset();
    th.join();

    return EXIT_SUCCESS;
}
